; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 600
WINDOWHEIGHT = 640

.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC) shl 32 + (sizeof WNDCLASSEX)
	push	rax                     ;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT

        mov	hWin,rcx
	xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
	invoke	RtlExitUserProcess,NULL
wmCREATE:invoke	GetDC    ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax;eax=hDC
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hrc,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;GLInit----------------------------------
;     ()
	invoke glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST;
;     
	invoke glMatrixMode,GL_PROJECTION;     ()
;    , ..    (  glcall ..     8 )
	movq	xmm0,constd90
	movq	xmm1,ratio
	movq	xmm2,constd0_1
	movq	xmm3,constd100
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
;-----------------------------------------
	invoke	glEnable,GL_ALPHA_TEST
	invoke	glEnable,GL_DEPTH_TEST
	invoke	glEnable,GL_COLOR_MATERIAL
	invoke	glEnable,GL_LIGHTING
	invoke	glEnable,GL_LIGHT0
	invoke	glEnable,GL_BLEND
	invoke	glBlendFunc,GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA
	mov	r8d,offset pos
	invoke	glLightfv,GL_LIGHT0, GL_POSITION
	mov	r8d,offset dir
	invoke	glLightfv,GL_LIGHT0,GL_SPOT_DIRECTION
	invoke	gluNewQuadric
        mov	quadObj,rax
        jmp	wmBYE
wmSIZE:;;     
	movzx	r8,r9w
	shr	r9,16
	invoke	glViewport,0,0
	invoke	glMatrixMode,GL_PROJECTION
	invoke	glLoadIdentity
	mov	rax,constd5
	movq	xmm3,rax;top
	movq	xmm1,rax;right
	mov	rax,constd_5
	movq	xmm2,rax ;bottom
	movq	xmm0,rax;left,
	invoke	glOrtho,,,,,constd2,constd12;nearVal,farVal
	movq	xmm3,rbx;centerX
	movd	xmm2,constd5;eyeZ
	movq	xmm1,rbx;eyeY
	movq	xmm0,rbx;eyeX
	invoke	gluLookAt,,,,,rbx,rbx,rbx,constd1,rbx;centerY,centerZ,upX,upY,upZ
  	invoke	glMatrixMode,GL_MODELVIEW

        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
;;  
        invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
	invoke	glPushMatrix;  
;spheres
	movq	xmm2,rbx      ;z
	movq	xmm1,constd4;y
	movq	xmm0,constd_4;x
	invoke	glTranslated;(-4,4,0);
	movq	xmm2,rbx
	movq	xmm1,rbx
	movq	xmm0,constd1;red
	invoke	glColor3d;(1,0,0);
	invoke	gluQuadricDrawStyle,quadObj, GLU_FILL
	movq	xmm1,constd0_5
	invoke	gluSphere,quadObj,,5, 5
 
	movq	xmm2,rbx
	movq	xmm1,rbx
	movq	xmm0,constd1_5
	invoke	glTranslated;(1.5,0,0);
	movq	xmm2,rbx
	movq	xmm1,constd1;green
	movq	xmm0,rbx
	invoke	glColor3d;(0,1,0);
	invoke	gluQuadricDrawStyle,quadObj,GLU_LINE
	movq	xmm1,constd0_75
	invoke	gluSphere,quadObj,,10,10
 
	movq	xmm2,rbx
	movq	xmm1,rbx
	movq	xmm0,constd2
	invoke	glTranslated;(1.5,0,0);
	movq	xmm2,constd1;blue
	movq	xmm1,rbx
	movq	xmm0,rbx
	invoke	glColor3d;(0,1,0);
	invoke	gluQuadricDrawStyle,quadObj, GLU_SILHOUETTE
	movq	xmm1,constd1
	invoke	gluSphere,quadObj,,15,15 

	movq	xmm2,rbx
	movq	xmm1,rbx
	movq	xmm0,constd3
	invoke	glTranslated;(1.5,0,0);
	mov	rax,constd1
	movq	xmm2,rax;blue
	movq	xmm1,rax
	movq	xmm0,rbx
	invoke	glColor3d;(0,1,1);
	invoke	gluQuadricDrawStyle,quadObj, GLU_POINT
	movq	xmm1,constd1_25
	invoke	gluSphere,quadObj,,20,20
	invoke	glPopMatrix
;cylinders
	invoke	glPushMatrix
	movq	xmm2,rbx    ;z
	movq	xmm1,constd1;y
	movq	xmm0,constd_4;x
	invoke	glTranslated;(-6.5,-3.3,0);
	movq	xmm3,rbx     ;z 	
	movq	xmm2,rbx     ;y
	movq	xmm1,constd_1;x
	movq	xmm0,constd45
	invoke	glRotated;45,-1,0,0);
	movq	xmm2,rbx
	movq	xmm1,rbx
	movq	xmm0,constd1;red
	invoke	glColor3d;(1,0,0);
	invoke	gluQuadricDrawStyle,quadObj,GLU_FILL

	movq	xmm3,constd2
	movq	xmm2,constd1
	movq	xmm1,constd0_5
	invoke	gluCylinder,quadObj,,,,5,5;quadObj, 0.5, 1, 2, 5, 5 
 	movq	xmm2,rbx
	movq	xmm1,rbx
	movq	xmm0,constd2
	invoke	glTranslated;(2,0,0);
	movq	xmm2,rbx
	movq	xmm1,constd1;green
	movq	xmm0,rbx
	invoke	glColor3d;(0,1,0);
	invoke	gluQuadricDrawStyle,quadObj,GLU_LINE
        movq	xmm3,constd2
        movq	xmm2,constd0_5
        movq	xmm1,constd1
	invoke	gluCylinder,quadObj,,,,10,10;1, 0.5, 2, 10, 10

 	movq	xmm2,rbx
	movq	xmm1,rbx
	movq	xmm0,constd2_5
	invoke	glTranslated;(2.5,0,0);
	movq	xmm2,constd1
	movq	xmm1,rbx;green
	movq	xmm0,rbx
	invoke	glColor3d;(0,0,1);
	invoke	gluQuadricDrawStyle,quadObj,GLU_SILHOUETTE
	movq	xmm3,constd2
	movq	xmm2,constd1
	movq	xmm1,constd0_5
	invoke	gluCylinder,quadObj,,,,15,15 ;, 0.5, 1.0, 2.0, 15, 15); 

 	movq	xmm2,rbx
	movq	xmm1,rbx
	movq	xmm0,constd3
	invoke	glTranslated; glTranslated(3,0,0);
	mov	rax,constd1
	movq	xmm2,rax
	movq	xmm1,rax;green
	movq	xmm0,rbx
	invoke	glColor3d; glColor3d(0,1,1);
	invoke	gluQuadricDrawStyle,quadObj,GLU_POINT 
	movq	xmm3,constd1_5
	movq	xmm2,constd1_25
	movq	xmm1,constd1
	invoke	gluCylinder,quadObj,,,,10,10; 
	invoke	glPopMatrix
;disks
	invoke	glPushMatrix
	movq	xmm2,rbx     ;z
	movq	xmm1,constd_1;y
	movq	xmm0,constd_4;x
	invoke	glTranslated;(-6.5,-5,0);
	movq	xmm2,rbx
	movq	xmm1,rbx
	movq	xmm0,constd1;red
	invoke	glColor3d;(1,0,0);
	invoke	gluQuadricDrawStyle,quadObj, GLU_FILL
	movq	xmm2,constd0_5
	movq	xmm1,constd0_3
	invoke	gluDisk,quadObj,,,5, 5
;2
 	movq	xmm2,rbx
	movq	xmm1,rbx
	movq	xmm0,constd2
	invoke	glTranslated;(1.5,0,0);
	movq	xmm2,rbx
	movq	xmm1,constd1;green
	movq	xmm0,rbx
	invoke	glColor3d;(0,1,0);
	invoke	gluQuadricDrawStyle,quadObj,GLU_LINE
        movq	xmm2,constd0_75
        movq	xmm1,constd0_5
	invoke	gluDisk,quadObj,,,10,10 
;3
 	movq	xmm2,rbx
	movq	xmm1,rbx
	movq	xmm0,constd2_5
	invoke	glTranslated;(2,0,0);
	movq	xmm2,constd1
	movq	xmm1,rbx
	movq	xmm0,rbx;red
	invoke	glColor3d;(0,0,1);
	invoke	gluQuadricDrawStyle,quadObj,GLU_SILHOUETTE
        movq	xmm2,constd1
        movq	xmm1,constd0_75
	invoke	gluDisk,quadObj,,,15,15 

 	movq	xmm2,rbx
	movq	xmm1,rbx
	movq	xmm0,constd3
	invoke	glTranslated;(3,0,0);
	mov	rax,constd1
	movq	xmm2,rax
	movq	xmm1,rax;green
	movq	xmm0,rbx
	invoke	glColor3d;(0,1,1);
	invoke	gluQuadricDrawStyle,quadObj,GLU_POINT
        movq	xmm2,constd1_25
        movq	xmm1,constd1
	invoke	gluDisk,quadObj,,,20,20 
	invoke	glPopMatrix
;partial disks
	invoke	glPushMatrix
	movq	xmm2,rbx      ;z
	movq	xmm1,constd_3_5;y
	movq	xmm0,constd_4;x
	invoke	glTranslated;(-6.5,-2.8,0);
	movq	xmm2,rbx
	movq	xmm1,rbx
	movq	xmm0,constd1;red
	invoke	glColor3d;1,0,0);
	invoke	gluQuadricDrawStyle,quadObj,GLU_FILL
	movq	xmm2,constd0_5
	movq	xmm1,constd0_3
	invoke	gluPartialDisk,quadObj,,,5,5,constd30,constd60
 
 	movq	xmm2,rbx
	movq	xmm1,rbx
	movq	xmm0,constd1_5
	invoke	glTranslated;(1.5,0,0);
	movq	xmm2,rbx
	movq	xmm1,constd1;green
	movq	xmm0,rbx
	invoke	glColor3d;(0,1,0);
	invoke	gluQuadricDrawStyle,quadObj,GLU_LINE

	movq	xmm2,constd0_75
	movq	xmm1,constd0_5
	invoke	gluPartialDisk,quadObj,,,10,10,constd60,constd100 

 	movq	xmm2,rbx
	movq	xmm1,rbx
	movq	xmm0,constd2
	invoke	glTranslated;(2,0,0);
	movq	xmm0,rbx
	movq	xmm1,rbx
	movq	xmm2,constd1
	invoke	glColor3d;(0,0,1);
	invoke	gluQuadricDrawStyle,quadObj,GLU_SILHOUETTE

	movq	xmm2,constd1
	movq	xmm1,constd0_75
	invoke	gluPartialDisk,quadObj,,,15,15,constd90,constd200

 	movq	xmm2,rbx
	movq	xmm1,rbx
	movq	xmm0,constd2_5
	invoke	glTranslated;(3,0,0);
	mov	rax,constd1
	movq	xmm2,rax
	movq	xmm1,rax;green
	movq	xmm0,rbx;red
	invoke	glColor3d;(0,1,1);
	invoke	gluQuadricDrawStyle,quadObj,GLU_POINT 

	movq	xmm2,constd1_25
	movq	xmm1,constd1
	invoke	gluPartialDisk,quadObj,,,20,20,constd180,constd300

	invoke	glPopMatrix
;   
        invoke	SwapBuffers,hDC
	lea	edx,ps
	invoke	EndPaint,hWin
wmBYE:	leave
	xor	eax,eax
	retn	
WndProc	endp
hDC	dq	?
hrc	dq	?;  
PixFrm	label	PIXELFORMATDESCRIPTOR 
;   
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1;  
;  ,     
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or \
	PFD_DRAW_TO_WINDOW 
  	iPixelType        db	PFD_TYPE_RGBA; RGBA 
  	cColorBits        db	16;   
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;  
  	cAlphaBits        db	0;  
  	cAlphaShift       db	0;  
  	cAccumBits        db	0;  
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;  
  	cDepthBits        db	0;32  Z- ( )
  	cStencilBits      db	0;  
  	cAuxBuffers       db	0;  
  	iLayerType        db	PFD_MAIN_PLANE;  
  	bReserved         db	0;
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;  

szClassName	db "Uncle Remus tales:#40 OpenGL - Sphere2",0
FileName	db "br_Rabbit3.cur",0
;double----------------------------
constd0_1	dq 0.1
constd0_3	dq 0.3
constd0_5	dq 0.5
constd0_75	dq 0.75
constd1		dq 1.0
constd_1	dq -1.0
constd1_25	dq 1.25
constd1_5	dq 1.5
constd2		dq 2.0
constd2_5	dq 2.5
constd3		dq 3.0
constd_3_5	dq -3.5
constd4		dq 4.0
constd_4        dq -4.0
constd5		dq 5.0
constd_5	dq -5.0
constd12	dq 12.0
constd30	dq 30.0
constd45	dq 45.0
constd60	dq 60.0
constd90	dq 90.0
constd100	dq 100.0
constd180	dq 180.0
constd200	dq 200.0
constd300	dq 300.0
ratio	        dq 0.9375
quadObj		dq ?
pos		dd 3.0,3.0,3.0,3.0,1.0;   
dir		dd -1.0,-1.0,-1.0
end